searchData={"items":[{"type":"extras","title":"opentelemetry_experimental","doc":"opentelemetry_experimental\n=====\n\nAn OTP application\n\nBuild\n-----\n\n    $ rebar3 compile","ref":"readme.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright 2021, Tristan Sloughter  .\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"},{"type":"extras","title":"Versioning and Releasing","doc":"# Versioning and Releasing\n\n[OTP] Applications and the [OpenTelemetry Spec] itself use [semver v2].\n\nIn this document, references to OTP concepts are distinguished by capitalizing the word\n(for example Application and Release) while the generic term (like release) is\nlowercase.\n\n[OTP]: http://erlang.org/doc/system_architecture_intro/sys_arch_intro.html\n[OpenTelemetry Spec]: https://github.com/open-telemetry/opentelemetry-specification\n[semver v2]: https://semver.org/spec/v2.0.0.html","ref":"versioning.html"},{"type":"extras","title":"Module Prefix - Versioning and Releasing","doc":"The module prefix for all modules in any of these core Applications is\n`otel`. This means modules can move between Applications without their name\nchanging. Because of Erlang's flat namespace, there is no code for a user to change\nwhen an API graduates from experimental to stable, if the user was\nusing the latest version of the experimental API.\n\nThis also allows flexibility for modules that might be in the SDK but are found\nto be better placed in the API, or vice versa. This has happened a few times in\nthe pre-1.0 world as functionality was floating from SDK to API at times.","ref":"versioning.html#module-prefix"},{"type":"extras","title":"OTP Applications - Versioning and Releasing","doc":"#","ref":"versioning.html#otp-applications"},{"type":"extras","title":"Experimental API (`opentelemetry_api_experimental`) - Versioning and Releasing","doc":"The experimental package is where any API that is not stable when 1.0 is\nreleased [MUST] live. At this time (prior to 1.0) that means Metrics and Logging.\n\nThis package will always be 0.x because it is never stable and modules will be\nremoved when they are moved to the stable API package. Breaking changes,\nas well as non-trivial additions, to the experimental API will only result in a\nminor version bump.\n[MUST]: https://tools.ietf.org/html/rfc2119#section-1\n\n#","ref":"versioning.html#experimental-api-opentelemetry_api_experimental"},{"type":"extras","title":"API (`opentelemetry_api`) - Versioning and Releasing","doc":"The API package must provide semver-defined backwards-compatibility\nonce a major version (e.g. 1.0.0) is released. When a particular part of the API\nbecomes stable, its modules are moved from `opentelemetry_api_experimental` to\n`opentelemetry_api` and a new minor release of both is published.\n\nAt the release of version 1.0, the following signal APIs will be included\nin `opentelemetry_api`:\n\n* Tracing\n* Baggage\n* Context\n\n#","ref":"versioning.html#api-opentelemetry_api"},{"type":"extras","title":"Experimental SDK (`opentelemetry_sdk_experimental`) - Versioning and Releasing","doc":"The experimental SDK contains the implementations for the APIs in the\nexperimental API of the same minor version. For example, there may be\nmultiple patch-level releases (`v0.3.2`, `v0.3.3`) of the experimental\nSDK for each minor version of the experimental API (`v0.3.0`).\nAny setup for signals contained in the experimental SDK must be done on startup\nof the experimental SDK. For example, setting the default Meter would be done\nin `start/2` of `opentelemetry_sdk_experimental`.\n\n#","ref":"versioning.html#experimental-sdk-opentelemetry_sdk_experimental"},{"type":"extras","title":"SDK (`opentelemetry`) - Versioning and Releasing","doc":"Functionality is implemented in this Application and the API is dynamically\nconfigured to use a particular SDK -- at this time there is only 1 SDK\nimplementation, the default implementation.\n\nA goal is that the latest SDK can always be used with any version of the API, so\nthat a user can always pull the latest implementation into their final Release\nto run with any API versions that were used in instrumented Applications within the\nRelease.\n\n#","ref":"versioning.html#sdk-opentelemetry"},{"type":"extras","title":"OTLP Exporter (`opentelemetry_exporter`) - Versioning and Releasing","doc":"Exporter implementations are tied to the SDK's public API.","ref":"versioning.html#otlp-exporter-opentelemetry_exporter"},{"type":"extras","title":"Releases - Versioning and Releasing","doc":"#","ref":"versioning.html#releases"},{"type":"extras","title":"Experimental API - Versioning and Releasing","doc":"As noted in the previous section, `opentelemetry_api_experimental` is versioned\nseparately from the rest and will always remain 0.x.\n\n#","ref":"versioning.html#experimental-api"},{"type":"extras","title":"API - Versioning and Releasing","doc":"Additions to the API are released with minor version bumps.\n\n#","ref":"versioning.html#api"},{"type":"extras","title":"Experimental SDK - Versioning and Releasing","doc":"As noted in the previous section, `opentelemetry_sdk_experimental` is versioned\nseparately from the rest, but in lockstep with `opentelemetry_api_experimental`,\nand will always remain 0.x.\n\n#","ref":"versioning.html#experimental-sdk"},{"type":"extras","title":"SDK - Versioning and Releasing","doc":"Additions to the SDK are released with minor version bumps.","ref":"versioning.html#sdk"},{"type":"extras","title":"Deprecation - Versioning and Releasing","doc":"Code is only marked as deprecated when the replacement is stable.\n\nUnlikely example: There is a Tracing v2 spec defined. The module will be named\n`otel_trace2` and the functions in `otel_trace` marked as deprecated.\n\nDeprecated functions must be marked with `-deprecated` in the module so that\n`xref` provides a warning about usage to the user.","ref":"versioning.html#deprecation"},{"type":"extras","title":"Removal - Versioning and Releasing","doc":"A major version bump is required to remove a signal or module.\n\nIn the unlikely example mentioned in the Deprecation section, this step would mean removal of the\noriginal module (`otel_trace`) and a major version bump release.","ref":"versioning.html#removal"},{"type":"extras","title":"Examples - Versioning and Releasing","doc":"Purely for illustration purposes, not intended to represent actual releases:\n\n- v1.0.0 release:\n   - `opentelemetry_api` 1.0.0\n     - Contains APIs for tracing, baggage, propagators\n   - `opentelemetry_api_experimental` 0.2.0\n     - Contains APIs for metrics\n   - `opentelemetry_sdk` 1.0.0\n   - `opentelemetry_sdk_experimental` 0.2.0\n- v1.15.0 release (with metrics)\n   - `opentelemetry_api` 1.15.0\n     - Contains APIs for tracing, baggage, propagators, metrics\n   - `opentelemetry_api_experimental` 0.42.0\n     - No longer contains APIs for metrics\n   - `opentelemetry_sdk` 1.15.0\n   - `opentelemetry_sdk_experimental` 0.42.0","ref":"versioning.html#examples"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]},"content_type":"text/plain"}